#include <bits/stdc++.h>

using namespace std;

map<pair<int, int>, int> react;

int n, m;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= m; ++i)
    {
        int x, y, z;
        cin >> x >> y >> z;

        react[make_pair(min(x, y), max(x, y))] = z;
    }

    vector<int> v;

    int k;
    cin >> k;

    for (int i = 1; i <= k; ++i)
    {
        int x;
        cin >> x;

        while (!v.empty() && v.back() == x)
        {
            v.pop_back();
        }

        v.push_back(x);

        while (v.size() >= 2 && (react.find(make_pair(min(v.back(), v[v.size() - 2]), max(v.back(), v[v.size() - 2]))) != react.end() || v.back() == v[v.size() - 2]))
        {
            if (v.back() == v[v.size() - 2])
            {
                v.pop_back();
                continue;
            }

            int curr = react[make_pair(min(v.back(), v[v.size() - 2]), max(v.back(), v[v.size() - 2]))];
            v.pop_back();
            v.pop_back();
            v.push_back(curr);
        }
    }

    cout << v.size() << endl;

    for (auto x : v)
    {
        cout << x << ' ';
    }

    cout << endl;

    return 0;
}
