#include <bits/stdc++.h>

using namespace std;

pair<int, int> op[100];

int n;

int p[100];
int perm[100];

int cost(const vector<int>& operetions)
{
    for (int i = 1; i <= n; ++i)
    {
        perm[i] = p[i];
    }

    for (int i = 0; i < operetions.size(); ++i)
    {
        int x = op[operetions[i]].first;
        int y = op[operetions[i]].second;

        if (2 * x > n || 2 * y > n)
        {
            return 100000;
        }

        swap(perm[2 * x], perm[2 * y]);
        swap(perm[2 * x - 1], perm[2 * y - 1]);
    }

    int cnt = 0;
    bool flag = false;

    do
    {
        flag = false;

        for (int i = 1; i < n; ++i)
        {
            if (perm[i] > perm[i + 1])
            {
                swap(perm[i], perm[i + 1]);
                ++cnt;
                flag = true;
            }
        }

    } while (flag == true);

    return cnt;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    int id = 0;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i + 1; j <= n; ++j)
        {
            op[++id] = make_pair(i, j);
        }
    }

    n *= 2;

    for (int i = 1; i <= n; ++i)
    {
        cin >> p[i];
    }

    vector<int> v;

    for (int i = 1; i <= id; ++i)
    {
        v.push_back(i);
    }

    vector<int> dumb;

    int answer = cost(dumb);

    do
    {
        vector<int> curr;

        for (int i = 0; i < v.size(); ++i)
        {
            curr.push_back(v[i]);

            answer = min(answer, cost(curr));
        }
    } while (next_permutation(v.begin(), v.end()));

    cout << answer << endl;

    return 0;
}
