#include<bits/stdc++.h>
using namespace std;

#define endl "\n"
#define cerr if(false) cerr

const long long MAX_N = 1e5 + 10;
const long long MAX_M = 5 * 1e4 + 10;
const long long MAX_K = 1e5 + 10;

int n, m, k;
vector<pair <int, int>> equ[MAX_N];
stack <int> s;

void print () {
    vector <int> temp;
    while (!s.empty()) {
        temp.push_back (s.top());
        s.pop();
    }
    for (int i = temp.size() - 1; i >= 0; i --) {
        cout << temp[i] << " ";
    }
    ///for (int i = temp.size() - 1; i >= 0; i --){
    ///    s.push(temp[i]);
    ///}
}

void print (int t) {
    ///cerr << " -- " << "(" <<  t << ") STACK: ";
    print ();
    ///cerr << " END --" << endl;;
}

int binary (int x, int ind) {
    int l = 0, r = equ[ind].size() - 1, mid, ans = -1;
    while (l <= r) {
        mid = (l + r) / 2;
        if (equ[ind][mid].first > x) {
            r = mid - 1;
        } else {
            ans = mid;
            l = mid + 1;
        }
    }
    return ans;
}

int doReact (int a, int b) {
    if (equ[a].size() < equ[b].size()) {
        int res = binary(b, a);
        if (res == -1 || equ[a][res].first != b) return -1;
        return equ[a][res].second;
    } else {
        int res = binary(a, b);
        if (res == -1 || equ[b][res].first != a) return -1;
        return equ[b][res].second;
    }

}

void checkForEqu (int x) {
    if (s.size() < 1) {
        s.push(x);
        return;
    }
    int res = doReact(s.top(), x);
    ///cerr << "TEST FOR " << s.top() << " " << x << endl;
    while (res != -1 && s.size() >= 1) {
        ///cerr << "REACT " << x << " " << s.top() << " to " << res << ". X now = " << res << endl;
        x = res;
        s.pop();
        ///print (2);
        if (s.size() == 0) break;
        res = doReact(s.top(), x);
    }
    if (s.empty() || s.top() != x) s.push(x);

    ///print (3);
}



int main () {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);


    cin >> n >> m;

    for (int i = 0; i < m; i ++) {
        int a, b, c;
        cin >> a >> b >> c;
        equ[a].push_back({b, c});
        equ[b].push_back({a, c});
    }

    for (int i = 0; i < n; i ++) {
        sort(equ[i].begin(), equ[i].end());
    }
    cin >> k;
    for (int i = 0; i < k; i ++) {
        int toAdd;
        cin >> toAdd;
        checkForEqu(toAdd);

        //print(1);
    }

    cout << s.size() << endl;
    print();
    return 0;
}
