#include<bits/stdc++.h>
using namespace std;

#define endl "\n"
#define cerr if(false) cerr

const long long MAX_N = 10000;

int n;
int a[MAX_N];
int indOf[MAX_N];

bool isSorted () {
    for (int i = 1; i <= 2 * n; i ++) {
        if (a[i] != i) return false;
    }
    return true;
}

bool canI (int depth) {
    if (isSorted()) return true;
    if(depth == 0) return isSorted();
    for (int x = 1; x < 2 * n; x ++) {
        bool doIReturn = false;
        swap(a[x], a[x + 1]);
        if (canI(depth - 1)) doIReturn = true;
        swap(a[x], a[x + 1]);
        if (doIReturn) return true;
    }
     return false;
}

int binary (int l_, int r_) {
    int l = l_, r = r_, mid, ans = r;
    while (l <= r) {
        mid = (l + r) / 2;
        //cout << mid << " - " << canI(mid) << endl;
        if (canI(mid)) {
            ans = mid;
            r = mid - 1;
        } else {
            l = mid + 1;
        }
    }
    return ans;
}

int main () {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= 2*n; i ++) {
        cin >> a[i];
    }
    for (int x = 1; x <= n; x ++){
        for (int y = x + 1; y <= n; y ++){
            if (a[2*x - 1] > a[2 * y - 1] && a[2*x] > a[2*y]) {
                //cout << "x = " << x << "; y = " << y << endl;
                swap (a[2*x - 1], a[2 * y - 1]);
                swap (a[2*x], a[2 * y]);
            }
        }
    }
    int ans = 0, maxi = 0;
    for (int i = 1; i <= 2*n; i ++) {
        ans +=  abs(i - a[i]);
        maxi = max(maxi, abs(i - a[i]));
    }
    //cout << canI(2) << endl;
    //cout << canI(3) << endl;
    //cout << canI(4) << endl;
    //cout << canI(5) << endl;
    //cout << canI(6) << endl;
    cout << binary (maxi, ans) << endl;

    return 0;
}

