# include <iostream>
# include <unordered_map>
using namespace std;

const long long MAX=1e6+1;
long long n,q;
long long a[MAX];

unordered_map<int, int> m;

void solve()
{
    long long ans=0;
    for(int i=1;i<=n;i++)
    {
        long long curr=0;
        for(int j=i;j<=n;j++)
        {
            m[a[j]]++;
            if(m[a[j]]==1) curr++;
            ans=ans+curr;
        }

        for(int j=i;j<=n;j++) m[a[j]]--;
    }

    cout<<ans<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>q;
    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
    }

    solve();
    for(int i=1;i<=q;i++)
    {
        int pos,x;
        cin>>pos>>x;
        a[pos]=x;
        solve();
    }
    return 0;
}
