#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 10;
int n, m;
map< pair<int, int>, int > storage;

void read(){
    cin >> n >> m;
    for(int i = 1;i <= m;i++){
        int a, b, c;
        cin >> a >> b >> c;
        storage[make_pair(a, b)] = storage[make_pair(b, a)] = c;
    }
}

void solve(){
    int k;
    cin >> k;
    stack<int> s;
    for(int i = 1;i <= k;i++){
        int a;
        cin >> a;
        if(s.empty()){
            s.push(a);
            continue;
        }
        if(!storage[make_pair(a, s.top())] && s.top() != a)
            s.push(a);
        else{
            if(s.top() == a)
                continue;
            s.push(a);
            while(!s.empty()){
                int x = s.top(); s.pop();
                int y = s.top(); s.pop();
                int t = storage[make_pair(x, y)];
                if(t == 0){
                    s.push(y);
                    s.push(x);
                    break;
                }
                if(!s.empty() && s.top() == t)
                    break;
                s.push(t);
                if(s.size() == 1)
                    break;
            }
        }
    }
    stack<int> ans;
    while(!s.empty()){
        ans.push(s.top());
        s.pop();
    }
    cout << ans.size() << endl;
    while(!ans.empty()){
        cout << ans.top() << " ";
        ans.pop();
    }
    cout << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
