#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
int N, Q;
int a[MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N >> Q;

    for(int i=1; i<=N; i++)
    {
        cin >> a[i];
    }
}

void update(int pos, int x)
{
    a[pos]=x;
}

void query()
{
    int ans=0;

    for(int l=1; l<=N; l++)
    {
        unordered_map<int, bool> visited;
        int add=0;

        for(int r=l; r<=N; r++)
        {
            if(!visited[a[r]])
            {
                add++;
                visited[a[r]]=true;
            }

            ans+=add;
        }
    }

    cout << ans << '\n';
}

void solve()
{
    query();

    while(Q--)
    {
        int pos, x;
        cin >> pos >> x;
        update(pos, x);
        query();
    }
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}

