#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
int N, Q;
int a[MAXN];
int code=0;
unordered_map<int, int> decode;

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N >> Q;

    for(int i=0; i<N; i++)
    {
        cin >> a[i];

        if(decode[a[i]]==0)
        {
            code++;
            decode[a[i]]=code;
        }
    }
}

void query()
{
    long long ans=0;
    long long buff=0, add=0;
    int idx[MAXN]= {};
    vector<int> visit[MAXN];

    for(int r=0; r<N; r++)
    {
        if(visit[decode[a[r]]].empty())
        {
            add++;
        }

        visit[decode[a[r]]].push_back(r);
        ///cout << a[r] << " ";

        //cout << add << " ";
        buff+=add;
    }

    for(int l=0; l<N-1; l++)
    {
        ///cout << buff << " ";
        ans+=buff;

        if(visit[decode[a[l]]].size()==idx[decode[a[l]]]+1)
        {
            buff-=(N-l);
        }
        else
        {
            buff-=(visit[decode[a[l]]][idx[decode[a[l]]]+1]-visit[decode[a[l]]][idx[decode[a[l]]]]);
            idx[decode[a[l]]]++;
        }
    }

    ans++;

    cout << ans << '\n';
}

void solve()
{
    query();

    while(Q--)
    {
        int pos, x;
        cin >> pos >> x;
        a[pos-1]=x;

        if(decode[x]==0)
        {
            code++;
            decode[x]=code;
        }

        query();
    }
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}
