#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
int N;
int a[2*MAXN];
int ans=1e9;
vector<pair<int, int>> groups;

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;

    for(int i=0; i<2*N; i++)
    {
        cin >> a[i];

        if(i%2==1)
        {
            groups.push_back({a[i-1], a[i]});
        }
    }
}

void calc()
{
    int index[10];

    for(int i=0; i<groups.size(); i++)
    {
        index[groups[i].first]=(i+1)*2-1;
        index[groups[i].second]=(i+1)*2;
    }

    int curr=0;

    for(int i=1; i<=2*N; i+=2)
    {
        curr+=(abs(index[i]-index[i+1])-1);

        if(index[i]>index[i+1])
        {
            curr++;
        }
    }

    ans=min(ans, curr);
}

void bruteforce()
{
    do
    {
        calc();
    }
    while(next_permutation(groups.begin(), groups.end()));

    cout << ans;
}

int main()
{
    fastIO();
    read();
    bruteforce();
    return 0;
}
