#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n, q;

int a[maxn];

vector<int> pos0;
vector<int> pos1;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> q;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];

        if (a[i] == 0)
        {
            pos0.push_back(i);
        }
        else
        {
            pos1.push_back(i);
        }
    }

    long long ans = 0;

    for (int i = 1; i <= n; ++i)
    {
        if (a[i] == 0)
        {
            int l = 0;
            int r = pos1.size() - 1;

            while (l <= r)
            {
                int mid = (l + r) / 2;

                if (pos1[mid] >= i)
                {
                    r = mid - 1;
                }
                else
                {
                    l = mid + 1;
                }
            }

            if (l == pos1.size())
            {
                ans += (n - i + 1);
            }
            else
            {
                ans += (pos1[l] - i) + (n - pos1[l] + 1) * 2;
            }
        }
        else
        {
            int l = 0;
            int r = pos0.size() - 1;

            while (l <= r)
            {
                int mid = (l + r) / 2;

                if (pos0[mid] >= i)
                {
                    r = mid - 1;
                }
                else
                {
                    l = mid + 1;
                }
            }

            if (l == pos0.size())
            {
                ans += (n - i + 1);
            }
            else
            {
                ans += (pos0[l] - i) + (n - pos0[l] + 1) * 2;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
