#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n, q;

int a[maxn];

vector<int> pos[2 * maxn];
bool seen[2 * maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> q;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];

        pos[a[i]].push_back(i);
    }

    long long ans = 0;

    for (int i = 1; i <= n; ++i)
    {
        if (seen[a[i]] == false)
        {
            ans += (1LL * (n - i + 1)) * (1LL * i);
            seen[a[i]] = true;
            continue;
        }

        int l = 0;
        int r = pos[a[i]].size() - 1;

        while (l <= r)
        {
            int mid = (l + r) / 2;

            if (pos[a[i]][mid] < i)
            {
                l = mid + 1;
            }
            else
            {
                r = mid - 1;
            }
        }

        ans += (1LL * (n - i + 1)) * (1LL * i - pos[a[i]][r]);
    }

    cout << ans << endl;

    return 0;
}
/*
8 0
1 2 3 3 2 1 2 1
*/
