#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

int n, q;

int a[maxn];

set<int> pos[maxn];

void solve_subtask4()
{
    long long ans = 0;

    vector<int> pos0;
    vector<int> pos1;

    for (int i = 1; i <= n; ++i)
    {
        if (a[i] == 2)
        {
            pos0.push_back(i);
        }
        else
        {
            pos1.push_back(i);
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        if (a[i] == 2)
        {
            int l = 0;
            int r = pos1.size() - 1;

            while (l <= r)
            {
                int mid = (l + r) / 2;

                if (pos1[mid] >= i)
                {
                    r = mid - 1;
                }
                else
                {
                    l = mid + 1;
                }
            }

            if (l == pos1.size())
            {
                ans += (n - i + 1);
            }
            else
            {
                ans += (pos1[l] - i) + (n - pos1[l] + 1) * 2;
            }
        }
        else
        {
            int l = 0;
            int r = pos0.size() - 1;

            while (l <= r)
            {
                int mid = (l + r) / 2;

                if (pos0[mid] >= i)
                {
                    r = mid - 1;
                }
                else
                {
                    l = mid + 1;
                }
            }

            if (l == pos0.size())
            {
                ans += (n - i + 1);
            }
            else
            {
                ans += (pos0[l] - i) + (n - pos0[l] + 1) * 2;
            }
        }
    }

    cout << ans << endl;
}

bool check()
{
    for (int i = 1; i <= n; ++i)
    {
        if (a[i] > 2)
        {
            return false;
        }
    }

    return true;
}

int num = 0;
char sym;

int read()
{
    num = 0;
    sym = getchar();

    while (isdigit(sym) == false)
    {
        sym = getchar();
    }

    while (isdigit(sym) == true)
    {
        num = num * 10 + (sym - '0');
        sym = getchar();
    }

    return num;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    n = read();
    q = read();

    for (int i = 1; i <= n; ++i)
    {
        a[i] = read();

        pos[a[i]].insert(i);
    }

    if (check() == true && q == 0)
    {
        solve_subtask4();
        return 0;
    }

    long long ans = 0;

    for (int i = 1; i <= n; ++i)
    {
        auto it = lower_bound(pos[a[i]].begin(), pos[a[i]].end(), i);

        if (it == pos[a[i]].begin())
        {
            ans += (1LL * (n - i + 1)) * (1LL * i);
        }
        else
        {
            --it;
            ans += (1LL * (n - i + 1)) * (1LL * (i - *it));
        }
    }

    cout << ans << "\n";

    for (int p = 1; p <= q; ++p)
    {
        int idx, x;

        idx = read();
        x = read();

        if (a[idx] == x)
        {
            cout << ans << "\n";
            continue;
        }

        int prv = 0;

        for (auto index : pos[a[idx]])
        {
            ans -= (1LL * (n - index + 1) * (1LL * (index - prv)));
            prv = index;
        }

        prv = 0;

        for (auto index : pos[x])
        {
            ans -= (1LL * (n - index + 1) * (1LL * (index - prv)));
            prv = index;
        }

        prv = 0;

        pos[a[idx]].erase(idx);

        for (auto index : pos[a[idx]])
        {
            ans += (1LL * (n - index + 1) * (1LL * (index - prv)));
            prv = index;
        }

        prv = 0;

        a[idx] = x;

        pos[a[idx]].insert(idx);

        for (auto index : pos[a[idx]])
        {
            ans += (1LL * (n - index + 1) * (1LL * (index - prv)));
            prv = index;
        }

        cout << ans << "\n";
    }

    return 0;
}
/*
8 4
1 2 3 3 2 1 2 1
6 3
5 4
5 3
1 1
*/
