#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

int n, q;

int a[maxn];

set<int> pos[maxn];

vector<int> position[maxn];

void solve_subtasks4or5()
{
    long long ans = 0;

    for (int i = 1; i <= n; ++i)
    {
        position[a[i]].push_back(i);
    }

    for (int i = 1; i <= n; ++i)
    {
        if (i == position[a[i]][0])
        {
            ans += (1LL * i) * (1LL * (n - i + 1));
            continue;
        }

        int l = 0;
        int r = position[a[i]].size() - 1;

        while (l <= r)
        {
            int mid = (l + r) / 2;

            if (position[a[i]][mid] < i)
            {
                l = mid + 1;
            }
            else
            {
                r = mid - 1;
            }
        }

        ans += (1LL * (n - i + 1)) * (1LL * (i - position[a[i]][r]));
    }

    cout << ans << endl;
}

bool check()
{
    for (int i = 1; i <= n; ++i)
    {
        if (a[i] > 2)
        {
            return false;
        }
    }

    return true;
}

int num = 0;
char sym;

int read()
{
    num = 0;
    sym = getchar();

    while (isdigit(sym) == false)
    {
        sym = getchar();
    }

    while (isdigit(sym) == true)
    {
        num = num * 10 + (sym - '0');
        sym = getchar();
    }

    return num;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    n = read();
    q = read();

    for (int i = 1; i <= n; ++i)
    {
        a[i] = read();

        pos[a[i]].insert(i);
    }

    if (q == 0)
    {
        solve_subtasks4or5();
        return 0;
    }

    long long ans = 0;

    for (int i = 1; i <= n; ++i)
    {
        auto it = lower_bound(pos[a[i]].begin(), pos[a[i]].end(), i);

        if (it == pos[a[i]].begin())
        {
            ans += (1LL * (n - i + 1)) * (1LL * i);
        }
        else
        {
            --it;
            ans += (1LL * (n - i + 1)) * (1LL * (i - *it));
        }
    }

    cout << ans << "\n";

    for (int p = 1; p <= q; ++p)
    {
        int idx, x;

        idx = read();
        x = read();

        if (a[idx] == x)
        {
            cout << ans << "\n";
            continue;
        }

        int prv = 0;

        for (auto index : pos[a[idx]])
        {
            ans -= (1LL * (n - index + 1) * (1LL * (index - prv)));
            prv = index;
        }

        prv = 0;

        for (auto index : pos[x])
        {
            ans -= (1LL * (n - index + 1) * (1LL * (index - prv)));
            prv = index;
        }

        prv = 0;

        pos[a[idx]].erase(idx);

        for (auto index : pos[a[idx]])
        {
            ans += (1LL * (n - index + 1) * (1LL * (index - prv)));
            prv = index;
        }

        prv = 0;

        a[idx] = x;

        pos[a[idx]].insert(idx);

        for (auto index : pos[a[idx]])
        {
            ans += (1LL * (n - index + 1) * (1LL * (index - prv)));
            prv = index;
        }

        cout << ans << "\n";
    }

    return 0;
}
/*
8 4
1 2 3 3 2 1 2 1
6 3
5 4
5 3
1 1
*/
