#include <bits/stdc++.h>

using namespace std;

pair<int, int> op[4];

int n;

int p[10];
int perm[10];

int cost(const vector<int>& operetions)
{
    for (int i = 1; i <= n; ++i)
    {
        perm[i] = p[i];
    }

    for (int i = 0; i < operetions.size(); ++i)
    {
        int x = op[operetions[i]].first;
        int y = op[operetions[i]].second;

        if (2 * x > n || 2 * y < n)
        {
            return 100000;
        }

        swap(perm[2 * x], perm[2 * y]);
        swap(perm[2 * x - 1], perm[2 * y - 1]);
    }

    int cnt = 0;
    bool flag = false;

    do
    {
        flag = false;

        for (int i = 1; i < n; ++i)
        {
            if (perm[i] > perm[i + 1])
            {
                swap(perm[i], perm[i + 1]);
                ++cnt;
                flag = true;
            }
        }

    } while (flag == true);

    return cnt;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    op[1] = make_pair(1, 2);
    op[2] = make_pair(2, 3);
    op[3] = make_pair(1, 3);

    cin >> n;
    n *= 2;

    for (int i = 1; i <= n; ++i)
    {
        cin >> p[i];
    }

    vector<int> v;
    v.push_back(1);
    v.push_back(2);
    v.push_back(3);

    int answer = 50;

    do
    {
        vector<int> curr;

        for (int i = 0; i < 3; ++i)
        {
            curr.push_back(v[i]);

            //cout << "t " << answer << endl;

            answer = min(answer, cost(curr));

            //cout << "here " << cost(curr) << ' ' << answer << endl;

            /*if (cost(curr) == 0)
            {
                for (auto x : curr)
                {
                    cout << op[x].first << ' ' << op[x].second << endl;
                }
            }*/
        }
    } while (next_permutation(v.begin(), v.end()));

    cout << answer << endl;

    return 0;
}
