#include<bits/stdc++.h>
using namespace std;

#define endl "\n"
//#define cerr if(false) cerr

const long long MAX_N  = 1e5 + 10;
const long long MAX_Q  = 1e5 + 10;
const long long MAX_A  = 2000 + 10;
const long long INF  = 1e9;

int n, q;
int a[MAX_N];
bool cnt[MAX_A];

long long tree[MAX_N];

void build (int l, int r, int ind) {
    if (l == r) {
        tree[ind] = a[l];
        return;
    }

    int mid = (l + r) / 2;
    build (l, mid, ind * 2);
    build (mid + 1, r, ind * 2 + 1);

    tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
}

void update (int l, int r, int ind, int q, int x) {
    if (q > r || q < l) return;
    if (l == r) {
        tree[ind] = x;
        return;
    }
    int mid = (l + r) / 2;
    update (l, mid, ind * 2, q, x);
    update (mid + 1, r, ind * 2 + 1, q, x);
    tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
}

int sum (int l, int r, int ind, int ql, int qr) {
    if (ql > r || qr < l) return 0;
    if (ql >= l && qr <= r) return tree[ind];

    int mid = (l + r) / 2;
    return sum (l, mid, ind * 2, ql, qr) + sum (mid + 1, r, ind * 2 + 1, ql, qr);
}

long long findDiff() {
    long long ans = 0;
    for (int l = 1; l <= n; l ++) {
        for (int r = l; r <= n; r ++) {
            if (sum(1,  n, 1, l, r) > 0) ans += 2;
            else ans += 1;
        }
    }
    return ans;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> q;

    for (int i = 1; i <= n; i ++) {
        cin >> a[i];
    }

    cout << findDiff() << endl;

    for (int i = 0; i < q; i ++) {
        int pos, x;
        cin >> pos >> x;


        update(1, n, 1, pos, x);
        cout << findDiff() << endl;
    }


    return 0;
}
//1 + 2 + 2 + 1 + 2 + 1

