#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
# include <iostream>
# include <stack>
# include <map>
# include <tuple>
# include <utility>
# include <vector>
using namespace std;

const int MAX=1e6+1;
map<pair<int, int>, int> a;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int n,m;
    cin>>n>>m;

    for(int i=1; i<=n; i++)
    {
        a[ {i,i}]=i;
    }

    for(int i=1; i<=m; i++)
    {
        int x,y,p;
        cin>>x>>y>>p;
        a[ {x,y}]=p;
        a[ {y,x}]=p;
    }

    stack<int> s;
    int k;
    cin>>k;
    for(int i=1; i<=k; i++)
    {
        int d;
        cin>>d;
        while(s.size()>0 and a[ {d,s.top()}]!=0)
        {
             d=a[{d,s.top()}];
             s.pop();
        }
        s.push(d);
    }

    vector<int> ans;
    while(s.size()>0)
    {
        ans.push_back(s.top());
        s.pop();
    }

    cout<<ans.size()<<"\n";
    for(int i=ans.size()-1;i>=0;i--)
    {
        cout<<ans[i]<<" ";
    }
    return 0;
}
