# include <iostream>
# include <stack>
# include <unordered_map>
# include <vector>
using namespace std;

const int MAX=1e6+1;
const long long F=1e6;
unordered_map<long long, int> a;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int n,m;
    cin>>n>>m;
    int x,y,p;
    for(int i=1; i<=m; i++)
    {
        cin>>x>>y>>p;
        a[F*x+y]=p;
        a[F*y+x]=p;
    }

    stack<int> s;
    int k;
    cin>>k;
    int d;
    for(int i=1; i<=k; i++)
    {
        cin>>d;
        while(s.size()>0 and (s.top()==d or a[F*d+s.top()]!=0))
        {
             if(d!=s.top()) d=a[F*d+s.top()];
             s.pop();
        }
        s.push(d);
    }

    vector<int> ans;
    while(s.size()>0)
    {
        ans.push_back(s.top());
        s.pop();
    }

    cout<<ans.size()<<"\n";
    for(int i=ans.size()-1;i>=0;i--)
    {
        cout<<ans[i]<<" ";
    }
    return 0;
}
