# include <iostream>
# include <set>
# include <algorithm>
# include <tuple>
using namespace std;

const long long MAX=1e5+1;
long long a[MAX];
long long n,q;

pair<long long, long long> borders(long long id)
{
    int l=id,r=id;
    for(int i=1;i<id;i++)
    {
        if(a[i]!=a[id]) l=i;
    }

    for(int i=n;i>id;i--)
    {
        if(a[i]!=a[id]) r=i;
    }

    //cout<<l<<" "<<r<<endl;
    return {l,r};
}

long long solve(long long l, long long r)
{
    return (l+1)*(r+1);
}

long long change(long long id, long long x)
{
    long long l,r;
    tie(l,r)=borders(id);
    long long ans=0;
    ans=-solve(id-l,r-id);

    a[id]=x;
    tie(l,r)=borders(id);
    ans+=solve(id-l,r-id);
    return ans;
}

int main()
{
    cin>>n>>q;
    for(long long i=1;i<=n;i++)
    {
       a[i]=1;
    }

    long long ans=n*(n+1)/2;
    cout<<ans<<endl;
    for(long long i=1;i<=n;i++)
    {
        long long x;
        cin>>x;
        ans=ans+change(i,x);
        //cout<<i<<":"<<ans<<endl;
    }

    cout<<ans<<endl;
    return 0;
}
