#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
int N, M, Potions;
int K[MAXN];
map<pair<int, int>, int> w;

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;
    cin >> M;

    for(int i=0; i<M; i++)
    {
        int A, B, C;
        cin >> A >> B >> C;
        w[{A, B}]=C;
        w[{B, A}]=C;
    }

    cin >> Potions;

    for(int i=0; i<Potions; i++)
    {
        cin >> K[i];
    }
}

int is_reaction(int A, int B)
{
    return w[{A, B}];
}

void solve()
{
    stack<int> st;

    for(int i=0; i<Potions; i++)
    {
        int curr=K[i];
        ///cout << curr << " ";

        while(!st.empty())
        {
            int top=st.top();
            int update=is_reaction(top, curr);
            ///cout << i+1 << " : " << curr << " " << top << " " << update << '\n';

            if(update==0)
            {
                break;
            }

            curr=update;
            st.pop();
        }

        st.push(curr);
    }

    vector<int> ans;

    while(!st.empty())
    {
        if(ans.empty())
        {
            ans.push_back(st.top());
        }
        else
        {
            if(ans[ans.size()-1]!=st.top())
            {
                ans.push_back(st.top());
            }
        }

        st.pop();
    }

    reverse(ans.begin(), ans.end());
    cout << ans.size() << '\n';

    for(int i=0; i<ans.size(); i++)
    {
        cout << ans[i] << " ";
    }
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}
