#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
long N, M, Potions;
long K[MAXN];
map<pair<long, long>, long> w;

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;
    cin >> M;

    for(int i=0; i<M; i++)
    {
        long A, B, C;
        cin >> A >> B >> C;
        if(A<=B)
        {
            w[ {A, B}]=C;
        }
        else
        {
            w[ {B, A}]=C;
        }
    }

    cin >> Potions;

    for(int i=0; i<Potions; i++)
    {
        cin >> K[i];
    }
}

long is_reaction(long& A, long& B)
{
    if(A<=B)
    {
        return w[ {A, B}];
    }
    else
    {
        return w[ {B, A}];
    }
}

void solve()
{
    stack<long> st;

    for(int i=0; i<Potions; i++)
    {
        long curr=K[i];
        ///cout << curr << " ";

        while(!st.empty())
        {
            long top=st.top();
            long update=is_reaction(top, curr);
            ///cout << i+1 << " : " << curr << " " << top << " " << update << '\n';

            if(update==0)
            {
                break;
            }

            curr=update;
            st.pop();
        }

        st.push(curr);
    }

    vector<long> ans;

    while(!st.empty())
    {
        if(ans.empty())
        {
            ans.push_back(st.top());
        }
        else
        {
            if(ans[ans.size()-1]!=st.top())
            {
                ans.push_back(st.top());
            }
        }

        st.pop();
    }

    if(ans.empty())
    {
        cout << 0;
    }
    else
    {
        reverse(ans.begin(), ans.end());
        cout << ans.size() << '\n';

        for(int i=0; i<ans.size(); i++)
        {
            cout << ans[i] << " ";
        }
    }
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}